#!/bin/sh

echo "Content-type: text/html"
echo

case "$QUERY_STRING" in
    "2c52ea59e936e0e7")
	FILE_NAME="/var/log/syslog"
	;;
    "36fd72ca93c2048d")
	FILE_NAME="/mnt/data/.bootlog"
	;;
    "b5124e9abc99bdcf")
	FILE_NAME="/var/log/update.log"
	;;
    "71b2be9f2de46932")
	if [ -r /etc/default/softplc ]; then
	    . /etc/default/softplc
	fi
	FILE_NAME="`echo $LOG_FILE`"
	;;
    "e5c348e3d0504246")
	if [ -r /etc/default/plcsync ]; then
	    . /etc/default/plcsync
	fi
	FILE_NAME="`echo $LOG_FILE`"
	;;
    "86936a46850b7a90")
	if [ -r /etc/default/plccoms ]; then
	    . /etc/default/plccoms
	fi
	FILE_NAME="`echo $LOG_FILE`"
	;;
    "d3cb612303a873dd")
	if [ -r /etc/default/minibrowser ]; then
	    . /etc/default/minibrowser
	fi
	FILE_NAME="`echo $LOG_FILE`"
	;;
    *)
	;;
esac

#TITLE_NAME=`echo $FILE_NAME | sed s/'.log.gz'/''/`
TITLE_NAME=`echo $FILE_NAME | sed s/'\.log$'/''/`

echo "<HEAD>"
if [ "$TITLE_NAME" ]; then
    echo "<TITLE>`basename $TITLE_NAME`.log</TITLE>"
fi
echo "</HEAD>"

if [ ! -f "$FILE_NAME" ]; then
    if [ ! -f "$FILE_NAME".1 ]; then
	exit 1
    fi
fi

if [ "`echo "$FILE_NAME" | grep '.gz'`" ]; then
    gzip -c "$FILE_NAME" | sed s/'^'/'<A>'/g | sed s/'$'/'<\/A><BR>'/g
else
    if [ ! -f "$FILE_NAME".1 ]; then
	cat "$FILE_NAME" | sed s/'^'/'<A>'/g | sed s/'$'/'<\/A><BR>'/g
    else
	trlog -s "$FILE_NAME" | sed s/'^'/'<A>'/g | sed s/'$'/'<\/A><BR>'/g
    fi
fi

exit 0
